/***************************************************
*	  Aml Pages Plugin API
*	 9.0 Beta 6 build 1825  21.11.2006
*
*	() 1998-2006,   aka Carc
*
*	www.amlpages.hotmail.ru
*	amlpages@hotmail.ru, carc@rambler.ru
*	ICQ UIN: 86905722
*	: http://carc.fastbb.ru
*	: www.amlpages.hotmail.ru/Rus/plugring.htm
*
*	!
*	      
*	   
*	AML_PAGES_PLUGIN   plugins.h
***************************************************/

#ifndef AML_PLUGIN_INCLUDE_STORAGE //   
#define AML_PLUGIN_INCLUDE_STORAGE
#pragma pack(push)
#pragma pack(8)//   8 

//    Aml Pages
#ifndef AML_PAGES_PLUGIN// plugins.h   Aml Pages
	//     "" header`
	#include "PageTypeDecl.h"
#else// pugins.h   ,     
	enum PAGE_TYPE {PT_TEXT=0  //  
					,PT_RTF=2  //   (RTF)
					,PT_HTML=3  //  (HTML-)
					,PT_FOLDER=4  // 
					,PT_RECYCLED=5  // ( /)
					,PT_FOLDEROFSTICKS=6  //  
	};//enum PAGE_TYPE
#endif//#ifndef AML_PAGES_PLUGIN

#define AML_MAX_NAME 260	//   (char[])   Plugin API

#ifdef AML_PAGES_PLUGIN
	//      ( plugins.h   )
#ifndef __wtypes_h__
	#include <wtypes.h>// BSTR
#endif//#ifndef __wtypes_h__

#ifndef _RICHEDIT_//   RichEdit.h
	#include <richedit.h>//     RichEdit
#endif//#ifndef _RICHEDIT_

// Aml Pages Plugin API
#define AML_PAGES_PLUGIN_API_VERSION TEXT("9.0 Beta 6 build 1825")
#endif//#ifndef AML_PAGES_PLUGIN

/***************************************************
*	(  ( -VC)
****************************************************/
#ifndef UINT
	typedef unsigned int UINT;// , 32- (VC++ specific)
#endif//#ifndef UINT

#ifndef DWORD
	typedef unsigned long DWORD;// , 32-
#endif//#ifndef DWORD

// 
struct AML_EXTRAINFO {
	DWORD cbSize;				//   
	int nPageID;				//ID   ( -1)
	LPCTSTR lpszInfoID;			//  - 
	SYSTEMTIME stDateCreated;	// 
	SYSTEMTIME stDateModified;	// 
	DWORD dwInfoSize;			//   pInfo
	char* pInfo;				//     

	AML_EXTRAINFO():cbSize(sizeof(AML_EXTRAINFO))
		,nPageID(-1)
		,lpszInfoID(NULL)
		,dwInfoSize(0)
		,pInfo(NULL)
	{
		GetLocalTime(&stDateCreated);
		stDateModified=stDateCreated;
	}
		
};//struct AML_EXTRAINFO {

//     AML_EXTRAINFO
typedef BOOL (*PFUNC_ENUMEXTRAINFOPROC)(int nIndex, AML_EXTRAINFO* pInfo, LPARAM lParam);


//     ( )
struct AML_MODULEVERSIONINFO {
	DWORD cbSize;		//[in] -    ,  sizeof(AML_MODULEVERSIONINFO)
	DWORD dwMajor;		//[out] -     (e.g. 9.x.x.xxxx)
	DWORD dwMinor;		//[out] -     (  ), (e.g. x.0.x.xxxx)
	DWORD dwRevision;	//[out] -     (  ),  (e.g. x.x.1.xxxx)
	DWORD dwBuild;		//[out] -  , (e.g. x.x.x.1814)

	AML_MODULEVERSIONINFO():cbSize(sizeof(AML_MODULEVERSIONINFO))
		,dwMajor(0)
		,dwMinor(0)
		,dwRevision(0)
		,dwBuild(0) {}
};//struct AML_MODULEVERSIONINFO

//  -  RichEdit
enum {
	APFRIO_SEL=0x0001,			//-   ,   ,   
	APFRIO_PLAINTEXT=0x0002,	//-   ,   ,    RTF
	APFRIO_IN=0x0004			// ,   ,   
};//enum 

//       RichEdit
typedef void (CALLBACK * PFUNC_AML_RICHEDITIO)(long,long,LPARAM);

//  -   RichEdit
struct AML_RICHEDITIO {
	DWORD cbSize;						//[in] -  ,  sizeof(AML_RICHEDITIO)
	DWORD dwFlags;						//[in] -   
	BSTR bstrText;						//[in\out] - BSTR ,    (   APFRIO_IN   ,      )
	HWND hwndRichEdit;					//[in] - HWND  RichEdit
	PFUNC_AML_RICHEDITIO pfnCallBack;	//[in] -    ()
	LPARAM lParam;						//[in\out] - LPARAM     ()

	AML_RICHEDITIO():cbSize(sizeof(AML_RICHEDITIO))
		,dwFlags(0)
		,bstrText(NULL)
		,hwndRichEdit(NULL)
		,pfnCallBack(NULL)
		,lParam(NULL)
	{
	}
};//struct AML_RICHEDITIO {

//    AML_OPTIONS (dwMask)
enum {
	APFOPT_TEXTCOLOR=0x0001		//  dwTextColor (    )
   ,APFOPT_BKTEXTCOLOR=0x0002	//  dwBkTextColor (    )
   ,APFOPT_EDITORFONT=0x0004	//    (  )
};//enum 

//   Aml Pages
struct AML_OPTIONS {
	DWORD cbSize;				//[in]  -  ,  sizeof(AML_OPTIONS)
	DWORD dwMask;				//[in]  - 
	DWORD dwTextColor;			//[out] -    ,   APFOPT_TEXTCOLOR
	DWORD dwBkTextColor;		//[out] -    ,   APFOPT_BKTEXTCOLOR
	CHARFORMAT cfEditorFont;	//[out] -  ,   APFOPT_EDITORFONT
	LOGFONT lfEditorFont;		//[out] -  ,   APFOPT_EDITORFONT

	AML_OPTIONS():cbSize(sizeof(AML_OPTIONS)),dwMask(0),dwTextColor(0),dwBkTextColor(0)
	{
		memset((LPVOID)&cfEditorFont,0,sizeof(cfEditorFont));
		memset((LPVOID)&lfEditorFont,0,sizeof(cfEditorFont));
	}
};//struct AML_OPTIONS {


//  AML_AUTOTEXTCOMMAND
enum {
	APFAT_CMDRICHEDIT2=0x001,// RichEdit 2.0  
};//enum 

//   
struct AML_AUTOTEXTCOMMAND {
	DWORD cbSize;	//[in] -  ,  sizeof(AML_AUTOTEXTCOMMAND)
	BSTR bstrText;	//[in\out] -       
	DWORD dwFlags;	//[in] -  RichEdit  2.0  
	int nCursorPos;	//[out] -       
	
	AML_AUTOTEXTCOMMAND():cbSize(sizeof(AML_AUTOTEXTCOMMAND)),bstrText(NULL)
		,dwFlags(0),nCursorPos(0) 
	{}
};//struct AML_AUTOTEXTCOMMAND

//    " "
struct AML_PLUGINABOUTINFO {
	DWORD cbSize;			//[in]  ,  sizeof(AML_PLUGINABOUTINFO)
	HICON hIcon;			//[in]  
	BSTR bstrTitle;			//[in]   (  ) (  )
	BSTR bstrNameVersion;	//[in]     (  )
	BSTR bstrAbout;			//[in]    ( )
	BSTR bstrLink;			//[in]  	
	BSTR bstrCopyrights;	//[in]   (  )
	BSTR bstrURLToolTip;	//[in]   
	LPCTSTR lpszLinkText;	//[in]    NULL

#ifdef AML_PAGES_PLUGIN//     Aml Pages
	AML_PLUGINABOUTINFO()
		:cbSize(sizeof(AML_PLUGINABOUTINFO))
		,hIcon(NULL)
		,bstrTitle(NULL)
		,bstrNameVersion(NULL)
		,bstrAbout(NULL)
		,bstrLink(NULL)
		,bstrURLToolTip(NULL)
		,lpszLinkText(NULL)
	{
	}
#endif//#ifdef AML_PAGES_PLUGIN
};//struct AML_PLUGINABOUTINFO

struct AML_MBCHECKINFO {
	DWORD cbSize;				//[in]    ,  sizeof(AML_MBCHECKINFO)
	BSTR bstrCaption;			//[in]   MessageBox 
	BSTR bstrText;				//[in]  MessageBox
	HWND hwndParent;			//[in] HWND  
	UINT uType;					//[in]   (Windows SDK: MB_ICON, MB_OKCANCEL  ..)
	BSTR bstrButtonsText;		//[in]  Checkbox` ( "1\n2\n...\nN", N  checkbox`)
	BOOL* pbChecked;			//[in\out]   checkbox`, TRUE(-) , FALSE -   
	int nRetValue;				//[out]     MessageBox
	UINT* pnDisabledChecks;		//[in]     (0-N),  ,   NULL
	UINT cbDisabledChecksSize;	//[in]   pnDisabledChecks 
	HICON hIcon;				//[in]  ,   NULL
	DWORD dwReserved;			//	       

#ifdef AML_PAGES_PLUGIN
	AML_MBCHECKINFO():cbSize(sizeof(AML_MBCHECKINFO))
		,bstrCaption(NULL)
		,bstrText(NULL)
		,hwndParent(NULL)
		,uType(MB_OK)
		,bstrButtonsText(NULL)
		,pbChecked(NULL)
		,nRetValue(0)
		,pnDisabledChecks(NULL)
		,cbDisabledChecksSize(NULL)
		,hIcon(NULL)
		,dwReserved(NULL)
	{
	}
#endif//#ifdef AML_PAGES_PLUGIN
};//struct AML_MBCHECKINFO {

struct AML_MBRADIOINFO {
	DWORD cbSize;				//[in]    ,  sizeof(AML_MBRADIOINFO)
	BSTR bstrCaption;			//[in]   MessageBox
	BSTR bstrText;				//[in]  MessageBox
	HWND hwndParent;			//[in]  
	UINT uType;					//[in]    (Windows SDK: MB_ICON, MB_OKCANCEL  ..)
	BSTR bstrButtonsText;		//[in]   ( "1\n2\n...\nN", N  )
	int nChecked;				//[in\out]    ,  :  
	int nRetValue;				//[out]    MessageBox
	UINT* pnDisabledRadio;		//[in]   , ,   NULL
	UINT cbDisabledRadioSize;	//[in]   pnDisabledRadio
	HICON hIcon;				//[in]  , ,   NULL

#ifdef AML_PAGES_PLUGIN
	AML_MBRADIOINFO():cbSize(sizeof(AML_MBRADIOINFO))
		,bstrCaption(NULL)
		,bstrText(NULL)
		,hwndParent(NULL)
		,uType(MB_OK)
		,bstrButtonsText(NULL)
		,nChecked(0)
		,nRetValue(0)
		,pnDisabledRadio(NULL)
		,cbDisabledRadioSize(NULL)
		,hIcon(NULL)
	{
	}
#endif//#ifdef AML_PAGES_PLUGIN
};//struct AML_MBRADIOINFO {
 
//   AML_PAGES_PLUGIN  plugins.h   Aml Pages
#ifdef AML_PAGES_PLUGIN
	//  ( AmlPages.exe)
	typedef	LRESULT (__stdcall *PFUNC_APC_COMMAND)					(UINT,WPARAM,LPARAM);					//  Aml Pages			(required Aml Pages 9.00 b1742 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_MESSAGEBOXWITHCHECKBOXEX)	(AML_MBCHECKINFO*);						//MessageBox   CheckBox		(required Aml Pages 9.00 b1740 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_SETSTATUSBARTEXT)			(BSTR);									//    		(required Aml Pages 9.00 b1726 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_MESSAGEBOXWITHRADIO)		(AML_MBRADIOINFO*);						//MessageBox  			(required Aml Pages 9.00 b1726 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_GETMODULEVERSIONINFOEX)	(HMODULE,AML_MODULEVERSIONINFO*);		//  				(required Aml Pages 9.00 b1711 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_GETMODULEVERSIONINFO)		(LPCTSTR,AML_MODULEVERSIONINFO*);		//  				(required Aml Pages 9.00 b1625 or later)
	typedef HWND	(__stdcall *PFUNC_APC_GETMAINWND)				(void);									// HWND   Aml Pages
	typedef BOOL	(__stdcall *PFUNC_APC_CONVERTTEXT)				(LPCTSTR,BSTR*,BOOL);					//  (PlaintText<->RTF)
	typedef int		(__stdcall *PFUNC_APC_MESSAGEBOXWITHCHECKBOX)	(LPCTSTR,UINT,LPCTSTR,BOOL*);			//MessageBox  					(required Aml Pages 9.00 b1593 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_DISPLAYPASSWORDDIALOG)	(BSTR*,BOOL,BOOL,LPCTSTR,BOOL,LPCTSTR);	// 							(required Aml Pages 9.00 b1622 or later)
	typedef UINT	(__stdcall *PFUNC_APC_GETAMLPAGESBUILDNUMBER)	(void);									//   Aml Pages		(required Aml Pages 9.00 b1622 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_REREADPLUGINSINFO)		(HMODULE);								//  				(required Aml Pages 9.00 b1631 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_GETAUTOTEXTCOMMAND)		(AML_AUTOTEXTCOMMAND*);					//  			(required Aml Pages 9.00 b1672) or later)
	typedef BOOL	(__stdcall *PFUNC_APC_GETOPTIONS)				(AML_OPTIONS*);							//  Aml Pages				(required Aml Pages 9.00 b1672 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_PLUGINABOUT)				(AML_PLUGINABOUTINFO*);					// " "					(required Aml Pages 9.00 b1688 or later)
	typedef BOOL	(__stdcall *PFUNC_APC_RICHINOUT)				(AML_RICHEDITIO*);						//-  RichEdit
	typedef BOOL	(__stdcall *PFUNC_APC_ADDEXTRAINFO)				(WORD,AML_EXTRAINFO*);					//  
	typedef BOOL	(__stdcall *PFUNC_APC_ENUMEXTRAINFO)			(WORD,PFUNC_ENUMEXTRAINFOPROC, LPCTSTR,int,LPARAM);	//  
	typedef BOOL	(__stdcall *PFUNC_APC_REMOVEEXTRAINFO)			(WORD,int);								//  
	typedef BOOL	(__stdcall *PFUNC_APC_SETEXTRAINFO)				(WORD,int,AML_EXTRAINFO*);				//  
	/***************************************************
	*	    
	*	(   ____  AMLPAGES.EXE)
	***************************************************/
	//    
	#define SIZE_AML_MENU_ITEM_INFO_VER2 1080	//AML_MENU_ITEM_INFO,  2
	#define SIZE_AML_MENU_ITEM_INFO_VER3 1340	//AML_MENU_ITEM_INFO,  3
	#define SIZE_AML_PAGEINFO_VER2 88			//AML_TREE_PASS, 
	#define SIZE_AML_PAGECONTENT_VER2 36		//AML_PAGECONTENT, +  hwnd
	#define SIZE_AML_INIT_PAGECONTENT_VER2 36	//AML_INIT_PAGECONTENT, +  hwnd

#endif//#ifdef AML_PAGES_PLUGIN

//   (   Aml_GetMenuItemInfo,   nPluginType  AML_MENU_ITEM_INFO)
enum PLUGIN_TYPE { APPT_TREEPASS=1		//   
					,APPT_SHOWDIALOG=2		//  
					,APPT_TEXTREAD=3		//  ,    ,  APPT_PAGECONTENT
					,APPT_TEXTREADSEL=4		//   ,   ,  APPT_PAGECONTENT
					,APPT_PAGECONTENT=5		// ()   
					,APPT_EXECCOMMAND=6		//   (reuqired 9.00 b1746 or later)
					};//enum PLUGIN_TYPE

enum AML_EVENTMASK {//     (. dwEventMask  AML_PLUGIN_INFO)
	APFEM_DOCEVENTS=1		//  
	,APFEM_EDITOREVENTS=2	//   
};//enum AML_EVENTMASK 

#ifdef AML_PAGES_PLUGIN
	enum AML_EVENTCODE {// 
		 AEC_DOCOPEN=1		// 
		,AEC_DOCCLOSE=2		// 
		,AEC_EXITAMLPAGES=3	//  Aml Pages
		,AEC_EDITOR=10		//  
	};
#else
	#include "EnumCodeEvent.h"
#endif//#ifdef AML_PAGES_PLUGIN

struct AML_EVENTDOC {//    
	DWORD cbSize;				//   
	WORD wDocID;				// ID 
	char szPath[AML_MAX_NAME];	//  
};//struct AML_EVENTDOC {

struct AML_EVENTEDITOR {//    
	DWORD cbSize;		//   
	HWND hwnd;			//HWND   
	UINT nMessage;		// Windows (, ,   ..)
	DWORD dwFlags;		// ""   
	POINT point;		//  (  "" )
	UINT nChar;			// WM_KEYUP, WM_KEYDOWN,WM_CHAR
	UINT nRepCnt;		// WM_KEYUP, WM_KEYDOWN,WM_CHAR
	CHARRANGE crSel;	//    
};//struct AML_EVENTEDITORMOUSE {

struct AML_EVENTINFO {//  					
	DWORD cbSize;						//   
	AML_EVENTCODE EventCode;			//  (.  AML_EVENTCODE)
	union EventInfo {					//  
		AML_EVENTDOC DocEvent;			//    
		AML_EVENTEDITOR EditorEvent;	//    
	} EventInfo;//union {

#ifndef AML_PAGES_PLUGIN
	AML_EVENTINFO(AML_EVENTCODE code)
	{
		memset(this,0,sizeof(AML_EVENTINFO));
		cbSize=sizeof(AML_EVENTINFO);
		ASSERT(code);
		ASSERT((code>=AEC_FIRST) && (code<=AEC_LAST));
		EventCode=code;
		switch(EventCode) {
		case AEC_DOCOPEN:
		case AEC_DOCCLOSE:
			EventInfo.DocEvent.cbSize=sizeof(AML_EVENTDOC);
			break;
		case AEC_EDITOR:
			EventInfo.EditorEvent.cbSize=sizeof(AML_EVENTEDITOR);
			break;			
		case AEC_EXITAMLPAGES:
			break;
		default:
			ASSERT(FALSE);
			break;
		};
	}
#endif//#ifndef AML_PAGES_PLUGIN
};//struct AML_EVENTINFO {

//   
struct AML_PLUGIN_INFO {
	DWORD cbSize;						//[in]    ,  sizeof(AML_PLUGIN_INFO)
	UINT nMenuCount;					//[out]    (   Aml_GetMenuItemInfo)
	char szMenuName[AML_MAX_NAME];		//[in\out]    ( nMenuCount>1)
	char szDescription[AML_MAX_NAME];	//[in\out]      
	UINT nMinRelease;					//[out]    Aml Pages    ,  0 ( ):  Aml Pages
	DWORD dwEventMask;					//[out]       
	DWORD dwFlags;						//[out]     

#ifndef AML_PAGES_PLUGIN//      Aml Pages 
	AML_PLUGIN_INFO& operator=(const AML_PLUGIN_INFO& info) 
	{
		if (&info!=this) {
#ifdef _DEBUG
			char compile_time_test_char_size[sizeof(char)-sizeof(TCHAR)+1]={0};
#endif//#ifdef _DEBUG
			cbSize=info.cbSize;
			nMenuCount=info.nMenuCount;
			strncpy(szMenuName,info.szMenuName,sizeof(szMenuName));
			strncpy(szDescription,info.szDescription,sizeof(szDescription));
			nMinRelease=info.nMinRelease;
			dwEventMask=info.dwEventMask;
			dwFlags=info.dwFlags;
		}

		return *this;
	}
	AML_PLUGIN_INFO():
		nMenuCount(0)
		,dwEventMask(0)
		,dwFlags(0)
	{
		cbSize=sizeof(AML_PLUGIN_INFO);
		szMenuName[0]='\0';
		szDescription[0]='\0';
		nMinRelease=0;
	}
	AML_PLUGIN_INFO(const AML_PLUGIN_INFO& info)
	{
		(*this)=info;
	}
#endif//#ifndef AML_PAGES_PLUGIN
};//struct AML_PLUGIN_INFO

/***************************************************
*	     
*	   (  )
***************************************************/

enum {
	 APF_TREEMENU=0x0001		//   
	,APF_EDITMENU=0x0002		//   
	,APF_SHLISTMENU=0x0004		//     (9.0.0.1743  )
	,APF_NOPLUGINSMENU=0x0008	//    "" (9.0.0.1743  )
	,APF_ABOUTINFO=0x0010		//   "  _"   " "
	,APF_SYSTRAYMENU=0x0020		//    

};//enum 

//    
struct AML_MENU_ITEM_INFO {
	DWORD cbSize;							//[in]    ,  sizeof(AML_MENU_ITEM_INFO)
	char szMenuName[AML_MAX_NAME];			//[out]   
	char szSBHint[AML_MAX_NAME];			//[out]     ()
	char szTTHint[AML_MAX_NAME];			//[out]   .  ()
	char szFunctionName[AML_MAX_NAME];		//[out]     DLL ,    
	PLUGIN_TYPE nPluginType;					//[out]    DLL  (.  PLUGIN_TYPE)
	LPARAM lParam;							//[out]  ,  AmlPages.exe  ,   0
	HICON hIcon;							//[out]    
	DWORD reserved;							//          
	DWORD reserved2;						//             ,/*BOOL bCanModified*/;
	UINT nMinRelease;						//[out] .   Aml Pages      .  0 ( )  Aml Pages
	UINT nMenuState;						//[out]   MF_CHECKED  
	DWORD reserved3;						//		,/*BOOL bReserved2*/
	DWORD dwFlags;							//[out]      
	char szInitFunctionName[AML_MAX_NAME];	//[out]    (       szFunctionName, 

#ifndef AML_PAGES_PLUGIN//       Aml Pages
	AML_MENU_ITEM_INFO()
	{
		cbSize=sizeof(AML_MENU_ITEM_INFO);
		szMenuName[0]='\0';
		szSBHint[0]='\0';
		szTTHint[0]='\0';
		szFunctionName[0]='\0';
		lParam=0;
		hIcon=NULL;
		nMinRelease=0;
		reserved=0;
		reserved2=0;
		nMenuState=0;
		reserved3=0;
		dwFlags=0;	//            
		szInitFunctionName[0]='\0';
		nPluginType=(PLUGIN_TYPE)0;
	}
	
	AML_MENU_ITEM_INFO& operator=(const AML_MENU_ITEM_INFO& info) 
	{
#ifdef _DEBUG//compile-time   char
		char compile_time_test_char_size[sizeof(char)-sizeof(TCHAR)+1]={0};
#endif//#ifdef _DEBUG

		nPluginType=info.nPluginType;
		strncpy(szMenuName,info.szMenuName,sizeof(szMenuName));
		strncpy(szSBHint,info.szSBHint,sizeof(szMenuName));
		strncpy(szTTHint,info.szTTHint,sizeof(szTTHint));
		strncpy(szFunctionName,info.szFunctionName,sizeof(szFunctionName));
		lParam=info.lParam;
		nMinRelease=info.nMinRelease;
		nMenuState=info.nMenuState;
		reserved2=info.reserved2;
		reserved=info.reserved;
		reserved3=info.reserved3;
		
		if (hIcon) {
			::DestroyIcon(hIcon);
		}

		if (info.hIcon) {
			hIcon=::CopyIcon(info.hIcon);			
		}
		else {
			hIcon=NULL;
		}

		if (info.hIcon) {
			::DestroyIcon(info.hIcon);
			const_cast<AML_MENU_ITEM_INFO&>(info).hIcon=NULL;
		}

		dwFlags=info.dwFlags;
		strncpy(szInitFunctionName,info.szInitFunctionName,sizeof(szInitFunctionName));
		return *this;
	}
	AML_MENU_ITEM_INFO(const AML_MENU_ITEM_INFO& info) 
	{
		(*this)=info;
	}
	~AML_MENU_ITEM_INFO()
	{
		if (hIcon) {
			const BOOL b=::DestroyIcon(hIcon);
		}
	}
#endif//#ifndef AML_PAGES_PLUGIN
};//struct AML_MENU_ITEM_INFO

/***************************************************
*	  , 
*	     
*	
***************************************************/	
struct AML_TEXTREAD {
	DWORD cbSize;		//[in]  ,  sizeof(AML_TEXTREAD)
	LPCTSTR lpszText;	//[in]    Aml Pages
	DWORD cbBufferSize;	//[in]      lpszText

#ifndef AML_PAGES_PLUGIN//    Aml Pages
	AML_TEXTREAD():cbSize(sizeof(AML_TEXTREAD)),lpszText(NULL),cbBufferSize(0) {}
#endif//#ifndef AML_PAGES_PLUGIN
};//struct AML_TEXTREAD

//  
enum {
	APFTP_STARTSELFOLDER=0x0001	//     ,  0 ( ),      Aml Pages
};//enum 


/***************************************************
*	     
*	  
***************************************************/
struct AML_INIT_TREEPASS {
	DWORD cbSize;	//[in]    ,  sizeof(AML_INIT_TREEPASS)
	BOOL bStart;	//[in] TRUE   ,  FALSE   
	LPARAM lParam;	//[in\out]  ,   Aml_GetMenuItemInfo
	BOOL bContinue;	//[in\out]   bStart==FALSE
	DWORD dwFlags;	//[out] , 0   , APFTP_STARTSELFOLDER     

#ifndef AML_PAGES_PLUGIN//     Aml Pages
	AML_INIT_TREEPASS():cbSize(sizeof(AML_INIT_TREEPASS)),bStart(TRUE)
		,lParam(NULL),bContinue(TRUE),dwFlags(0) {}
#endif//#ifndef AML_PAGES_PLUGIN
};//struct AML_INIT_TREEPASS

/***************************************************
*	   
***************************************************/
struct AML_PAGEINFO {
	DWORD cbSize;				//[in]  ,  sizeof(AML_PAGEINFO)
	SYSTEMTIME stDateCreated;	//[in]   
	SYSTEMTIME stDateModified;	//[in]   
	LPCTSTR lpszFullPagePath;	//[in]      Aml Pages (   C,   '\0')
	BOOL reserved;				//[in]     .   (bFolder)
	LPCTSTR lpszHeader;			//[in]  \ (   C,   '\0')
	DWORD reserved2	;			//      (cbHeaderSize)
	LPCTSTR lpszContent;		//[in]   (   C,   '\0')
	DWORD reserved3;			//      (cbContentSize)
	BOOL reserved4;				//[in]     .   (bFolder)(bFormattedText)
	BOOL* pbContinue;			//[in\out]   ?    (TRUE),  (FALSE)
	BOOL bRoot;					//[in]    (TRUE),  (FALSE)
	PAGE_TYPE pageType;			//[in]   (.  )
	UINT nNumber;				//[in]    0  ,  1, 2, 3  ..
	LPARAM lParam;				//[in\out]  
	int nPageID;				//[in]   ()  

#ifndef AML_PAGES_PLUGIN//     Aml Pages
	AML_PAGEINFO()
	{
		memset(this,0,sizeof(AML_PAGEINFO));
		cbSize=sizeof(AML_PAGEINFO);
		nPageID=(-1);
	}
#endif//#ifndef AML_PAGES_PLUGIN
} ;//struct AML_PAGEINFO

struct AML_EXECCOMMAND {
	DWORD cbSize;		//[in]    ,  sizeof(AML_EXECCOMMAND)
	LPARAM lParam;		//[in\out] lParam  ,   
	DWORD dwReserved;	//	    

#ifndef AML_PAGES_PLUGIN//     Aml Pages
	AML_EXECCOMMAND(LPARAM _lparam)
		:cbSize(sizeof(AML_EXECCOMMAND))
		,lParam(_lparam)
		,dwReserved(0)
	{
	}
#endif// #ifndef AML_PAGES_PLUGIN
};//struct AML_EXECCOMMAND

struct AML_INIT_EXECCOMMAND {
	DWORD cbSize;		//[in]    ,  sizeof(AML_INIT_EXECCOMMAND)
	BOOL bStart;		//[in] TRUE   , FALSE   
	BOOL bContinue;		//[in\out]    (  bStart==FALSE)
	LPARAM lParam;		//[in\out]     Aml_GetMenuItemInfo
	DWORD dwReserved;	//    

#ifndef AML_PAGES_PLUGIN//     Aml Pages
	AML_INIT_EXECCOMMAND(BOOL start,LPARAM _lparam):cbSize(sizeof(AML_INIT_EXECCOMMAND))
		,lParam(_lparam)
		,bStart(start)
		,bContinue(TRUE)
		,dwReserved(0)
	{
	}
#endif// #ifndef AML_PAGES_PLUGIN
};//struct AML_INIT_EXECCOMMAND

/***************************************************
     ,
***************************************************/
struct AML_PAGECONTENT {
	const DWORD cbSize;			//[in]    ,  sizeof(AML_PAGECONTENT)
	BSTR bstrContent;			//[in\out]  
	DWORD dwFlags;				//[in\out]   
	const PAGE_TYPE pageType;	//[in]   
	BOOL bChanged;				//[out]   TRUE (-),    
	CHARRANGE crSel;			//[in\out]    
	LPARAM lParam;				//[in\out]  
	const HWND hwnd;			//[in] HWND    (required Aml Pages 9.00 b1818 or later)
	const int nPageID;
	const WORD wDocID;

#ifndef AML_PAGES_PLUGIN//     Aml Pages	
	AML_PAGECONTENT(PAGE_TYPE page_type
		, const HWND _hwnd
		, const int page_id
		, const WORD doc_id
		):pageType(page_type)
		,cbSize(sizeof(AML_PAGECONTENT))
		,dwFlags(0)
		,bChanged(FALSE) 
		,lParam(0)
		,bstrContent(NULL)
		,hwnd(_hwnd)
		,nPageID(page_id)
		,wDocID(doc_id)
	{
		crSel.cpMin=crSel.cpMax=0;
	}		
#endif//#ifndef AML_PAGES_PLUGIN
};//struct AML_PAGECONTENT

//  AP_PAGECONTENT ( AML_PAGECONTENT.dwFlags)
enum {
	 APFPC_SEL=0x0001		//       ,    ()    
	,APFPC_PLAINTEXT=0x0002	//    Plain Text,      RTF
};//enum 

struct AML_INIT_PAGECONTENT {
	const DWORD cbSize;			//[in]    , sizeof(AML_INIT_PAGECONTENT)
	BOOL bStart;				//[in] TRUE:  (   ), FALSE:  (   )
	const PAGE_TYPE pageType;	//[in]  ,    PageTypeDecl.h
	DWORD dwFlags;				//[in\out]   ,   APFPC_xxxxx
	CHARRANGE crSel;			//[in]    
	BOOL bContinue;				//[in\out]    (   ),     FALSE (  TRUE)
	LPARAM lParam;				//[in\out]  
	const HWND hwnd;			//[in] HWND    (required Aml Pages 9.00 b1818 or later)
	const int nPageID;
	const WORD wDocID;


#ifndef AML_PAGES_PLUGIN//     Aml Pages	
	AML_INIT_PAGECONTENT(PAGE_TYPE page_type
		, const HWND _hwnd
		, int page_id
		, WORD doc_id
		):pageType(page_type)
		,cbSize(sizeof(AML_INIT_PAGECONTENT))
		,bStart(TRUE)
		,dwFlags(0)
		,bContinue(TRUE)
		,lParam(0)
		,hwnd(_hwnd)
		,nPageID(page_id)
		,wDocID(doc_id)
	{
		crSel.cpMin=crSel.cpMax=0;
	}
#endif//#ifndef AML_PAGES_PLUGIN
};//struct AML_INIT_PAGECONTENT

#ifndef AML_PAGES_PLUGIN 
	/***************************************************
	*	FUNCTIONS
	*	(      
	*	 Aml Pages)
	/***************************************************/

	//   ,   
	typedef BOOL (*PFUNC_AML_GETPLUGININFO)(AML_PLUGIN_INFO* pInfo);
	
	//     ,  
	typedef BOOL (*PFUNC_AML_GETMENUITEMINFO)(UINT nIndex, AML_MENU_ITEM_INFO* pInfo);
	
	// ,   ,  PLUGIN_TYPE: AP_TREEPASS
	typedef BOOL (*PFUNC_AML_TREEPASS)(AML_PAGEINFO* pTreePass);
	
	// ,  PLUGIN_TYPE: AP_TREEPASS
	typedef BOOL (*PFUNC_AML_INIT_TREEPASS)(AML_INIT_TREEPASS*);
	
	// ,   PLUGIN_TYPE: AP_SHOWDIALOG
	typedef BOOL (*PFUNC_AML_SHOWDIALOG)(HWND);
	
	/*   ,
	*	
	*	      ,
	*	 AP_PAGECONTENT	*/
	typedef BOOL (*PFUNC_AML_TEXTREAD)(AML_TEXTREAD*);
	
	//  , (  PLUGIN_TYPE: AP_PAGECONTENT)
	typedef BOOL (*PFUNC_AML_PAGECONTENT)(AML_PAGECONTENT*);
	
	// , (  PLUGIN_TYPE:)
	typedef BOOL (*PFUNC_AML_INIT_PAGECONTENT)(AML_INIT_PAGECONTENT*);
	
	//  ,   PLUGIN_TYPE:AP_EXECCOMMAND
	typedef BOOL (*PFUNC_AML_EXECCOMMAND)(AML_EXECCOMMAND*);

	// ,   PLUGIN_TYPE:AP_EXECCOMMAND
	typedef BOOL (*PFUNC_AML_INIT_EXECCOMMAND)(AML_INIT_EXECCOMMAND*);
	// ,   Aml Pages
	typedef BOOL (*PFUNC_AML_EVENTHANDLER)(AML_EVENTINFO*);
#endif //#ifndef AML_PAGES_PLUGIN

#ifndef AML_PAGES_PLUGIN 
	/***************************************************
	*	    Aml Pages
	*
	*	    ( ,
	*	   AMLPAGES.EXE)
	***************************************************/
	//(      )
	#define SIZE_AML_OPTIONS_VER2 76//  AML_OPTIONS  2
	#define SIZE_AML_PLUGINABOUTINFO_VER2 32//  AML_PLUGINABOUTINFO  2
	#define SIZE_AML_PLUGINABOUTINFO_VER3 36//  AML_PLUGINABOUTINFO  3
	#define SIZE_AML_PAGECONTENT_VER3 44//wDocID, nPageID
	#define SIZE_AML_INIT_PAGECONTENT_VER3 44//wDocID, nPageID

#endif //#ifndef AML_PAGES_PLUGIN

#pragma pack(pop)
#endif //#ifndef AML_PLUGIN_INCLUDE_STORAGE
