// Options.cpp: implementation of the COptions class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Options.h"

#ifndef _DEBUG
	#define REG_PATH TEXT("Software\\G&G Software\\Aml Pages\\Plugins\\CopyOnSel")
#else
	#define REG_PATH TEXT("Software\\G&G Software\\Aml Pages\\Plugins\\CopyOnSel Debug")
#endif

#define ENABLED TEXT("Enabled")

COptions::COptions()
{
	m_bEnabled=TRUE;
}

COptions& COptions::GetOptions()
{
	static COptions opt;
	static bool f=true;
	if (f) {
		opt.Read();
		f=false;
	}
	return opt;
}

void COptions::Write() const
{
	HKEY hkey=NULL;
	if (ERROR_SUCCESS==::RegCreateKey(HKEY_CURRENT_USER,REG_PATH ,&hkey)) {
		::RegSetValueEx(hkey,ENABLED,0,REG_DWORD,(BYTE*)&m_bEnabled,sizeof(m_bEnabled));
		::RegCloseKey(hkey);
	}
}

void COptions::Read()
{
	HKEY hkey=NULL;
	if (ERROR_SUCCESS==::RegOpenKey(HKEY_CURRENT_USER,REG_PATH ,&hkey)) {
		DWORD dwType=REG_DWORD;
		DWORD dwSize=sizeof(m_bEnabled);
		::RegQueryValueEx(hkey,ENABLED,NULL,&dwType,(BYTE*)&m_bEnabled,&dwSize);
		::RegCloseKey(hkey);
	}
}
